#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "StringArray.h"

class CigarCol
{
 public:
  int *fieldCount;
  int size;
  String fieldTypes;
  String tmp;
  int nClips_begin, nClips_end;
  
  CigarCol() { fieldCount=NULL; nClips_begin=nClips_end=0;};
  ~CigarCol(){ CigarClear(); };

  void GetClipLength_begin(String &cigar)
  {
    for(int i=0; i<cigar.Length(); i++)
    {
      if(cigar[i]!='S' && !isdigit(cigar[i])) return;
      if(cigar[i]=='S')
        { 
          nClips_begin = cigar.SubStr(0, i).AsInteger();
          return;
        }
    }
 };
 
 void GetClipLength_end(String &cigar)
{
	if(cigar[cigar.Length()-1] != 'S') return;

	for(int i=cigar.Length()-2; i>=0; i--)
	  if(!isdigit(cigar[i])) { 
	  nClips_end = cigar.SubStr(i+1, cigar.Length()-i-2).AsInteger(); 
	  return; }
  };
  
  void CigarParse(String &cigar) {
    size = 0;
    for  (int i = 0; i < cigar.Length(); i++)
      if (!isdigit(cigar[i])) size ++;

    fieldCount = new int[size];

    int k = 0; tmp = "";

    for  (int i = 0; i < cigar.Length(); i++)
      { if (isdigit(cigar[i])) tmp += cigar[i];
        else {
          fieldCount[k++] = tmp.AsInteger();
          tmp.Clear();
          fieldTypes += cigar[i];}
      }
  };

  void CigarClear(){
    if (fieldCount != NULL) {
      delete [] fieldCount;
      fieldCount = NULL;
      fieldTypes="";
      tmp="";}
  };
};

